$(document).ready(function(){
  runSlideOut();

  //search animation
  (function(window){

    // get vars
    var searchEl = $("#search");
    var labelEl = $(".fa-search");
    var searchInputEl = $("#search-terms");

    // register clicks and toggle classes
    labelEl.click( function(e) {
      e.preventDefault();
      if (searchEl.hasClass("focus")) {
        searchEl.removeClass("focus");
        labelEl.removeClass("active");
      } else {
        searchEl.addClass("focus");
        labelEl.addClass("active");
        searchInputEl.focus();
      }
    }); 

    // register clicks outisde search box, and toggle correct classes
    $(document).click( function(e) {
      var clickedID = e.target.id;
      if (clickedID != "search-terms" && clickedID != "search-label" && clickedID != "search-icon") {
        if (searchEl.hasClass("focus")) {
          searchEl.removeClass("focus");
          labelEl.removeClass("active");
        }
      }
    });
  }(window));

  $(window).scroll(function () {
    determineNavbarFixed( $(this), $('#main-navigation') );
    triggerSlideIns( $(this), [ $('div.itm-item'), $('div.news-item'), $('div.news-item-breaker') ]);
    updateNavbarUnderlineWidth();
  });

  $('#mobile-menu li.toggle-sub > a').click( function(e) {
    e.preventDefault();
    disableSidebarDropdown( $(this) );
  });

  $('#ik-presentation button, #ik-fact-sheet button').click( function() {
    //transformDropdown( $(this), $(this).siblings('.ik-dropdown-content') );
  });

  $('figure.fs-scroll-video a, #fs-primary-video a.lightbox').click( function(e) {
   e.preventDefault();
   var videoLink = $(this).attr('href');
   if ($('#my-lightbox').length > 0) { // #lightbox exists

     //insert img tag with clicked link's href as src value
     $('#lb-content').html('<iframe src="' + videoLink + '?title=0&amp;byline=0&amp;portrait=0&amp;autoplay=1&amp;color=ffffff" width="965" height="480" frameborder="0"></iframe>');

     //show lightbox window - you can use a transition here if you want, i.e. .show('fast')
     $('#my-lightbox').show();
   } else {
     var lightbox =
     '<div id="my-lightbox">' +
       '<div class="transperancy"></div>' +
       '<div id="lb-content">' +
         '<i>X</i>' +
         '<iframe src="' + videoLink + '?title=0&amp;byline=0&amp;portrait=0&amp;autoplay=1&amp;color=ffffff" width="965" height="480" frameborder="0"></iframe>' +
       '</div>' +
       // '<p>Click anywhere to close</p>' +
     '</div>';

     //insert lightbox HTML into page
     $('body').append(lightbox);
     $('#my-lightbox').on('click', function() {
       $('#my-lightbox').remove();
     });
   }});

  $('a[href=#top]').click(function() {
    $('html, body').animate({scrollTop:0}, 'slow');
    return false;
  });

  $('a[href*=#]:not([href=#])').click(function() {
    if (location.pathname.replace(/^\//,'') == this.pathname.replace(/^\//,'') && location.hostname == this.hostname) {
      var target = $(this.hash);
      target = target.length ? target : $('[name=' + this.hash.slice(1) +']');
      if (target.length) {
        $('html,body').animate({
          scrollTop: target.offset().top - 150
        }, 1000);
        return false;
      }
    }
  });
});

$.getDocHeight = function(){
  return Math.max(
      $(document).height(),
      $(window).height(),
      document.documentElement.clientHeight
  );
};

$.getScrollPercentage = function(){
  return 100 * Math.min(
    ($(window).height() + $(window).scrollTop()) / $.getDocHeight(),
    $(window).scrollTop()
    );
};

var determineNavbarFixed = function(t, navigation) {
  var y          = t.scrollTop();
  if (y >= 400) {
    navigation.addClass('fixed');
  } else {
    navigation.removeClass('fixed');
  }
};

var disableSidebarDropdown = function(menu_item) {
  // The hyperlink gets passed down, but we want the parent li element
  menu_item = menu_item.parent();

  // Toggle class on the li
  if(menu_item.hasClass("open")) {
    menu_item.removeClass('open');
  } else {
    menu_item.addClass('open');
  }
};

var updateNavbarUnderlineWidth = function() {
  $('#percentage-scroll-bar-span').css('width', $.getScrollPercentage() + '%');
};

var translateSubmenuPosition = function(menu_item) {
  // Get current position of the sub menu
  var position    = menu_item.position();
  var menu_child  = menu_item.find('ul.secondary-menu');

  // Translate it to the same offset as the position of the parent
  menu_child.css('padding-left', position.left + 'px');
};

var transformDropdown = function(button, presentation) {
  if(presentation.css('display') == 'none') {
    presentation.css('display', 'block');
    button.addClass('active');
  } else {
    presentation.css('display', 'none');
    button.removeClass('active');
  }
};

var triggerSlideIns = function(t, items) {
  for (var i = 0; i < items.length; i++) {
    if((( $.getDocHeight() - $(window).height()) - ( $.getDocHeight() - items[i].offset().top )) <= t.scrollTop()) {
      if(!items[i].hasClass('transitionSlideIn'))
      {
        items[i].addClass('transitionSlideIn');
      }
    } else { items[i].removeClass('transitionSlideIn'); }
  }
};

var runSlideOut = function() {
  var slideout = new Slideout({
    'panel': document.getElementById('panel'),
    'menu': document.getElementById('mobile-menu'),
    'padding': 256,
    'tolerance': 70
  });

  // Toggle button
  $('.toggle-button').click( function() {
    slideout.toggle();
  });
};
  /*
    There is meant to be  a scrollable featured videos section, but the client only has one video.
    Uncomment this and throw it in the document.ready if you want to activate multiple videos
  */

  // var featured_section = $('#fs-videos');
  // var scroll_container = $('#fs-scroll-container');
  // var up_arrow   = $('#fs-sc-up');
  // var down_arrow   = $('#fs-sc-down');

  // $(up_arrow).bind('mouseenter', function () {
  //  scroll_container.animate({'top': '0px'},'slow');
 //    }).bind('mouseleave', function () {

 //    });

 //    $(down_arrow).bind('mouseenter', function () {
  //  scroll_container.animate({'top': '-230px'},'slow');
 //    }).bind('mouseleave', function () {

 //    });

  // $(scroll_container).mouseleave(
  //   function(){returnToCenter();}
  // );
  // $(featured_section).mouseleave(
  //   function(){returnToCenter();}
  // );

  // function returnToCenter() {
  //  scroll_container.animate({'top': '-127px'}, { duration: 'slow', queue: false } );
  // };

  // $('figure.fs-scroll-video a, #fs-primary-video a').click( function(e) {
  //  e.preventDefault();
  //  var videoLink = $(this).attr('href');
  //  if ($('#my-lightbox').length > 0) { // #lightbox exists

  //    //insert img tag with clicked link's href as src value
  //    $('#lb-content').html('<iframe src="' + videoLink + '?title=0&amp;byline=0&amp;portrait=0&amp;autoplay=1&amp;color=ffffff" width="500" height="281" frameborder="0"></iframe>');

  //    //show lightbox window - you can use a transition here if you want, i.e. .show('fast')
  //    $('#my-lightbox').show();
  //  } else {
  //    var lightbox =
  //    '<div id="my-lightbox">' +
  //      '<div class="transperancy"></div>' +
  //      '<p>Click to close</p>' +
  //      '<div id="lb-content">' +
  //        '<iframe src="' + videoLink + '?title=0&amp;byline=0&amp;portrait=0&amp;autoplay=1&amp;color=ffffff" width="500" height="281" frameborder="0"></iframe>' +
  //      '</div>' +
  //    '</div>';

  //    //insert lightbox HTML into page
  //    $('body').append(lightbox);
  //    $('#my-lightbox').on('click', function() {
  //      $('#my-lightbox').hide();
  //    });
  //  }

  // });